diff --git a/libr/debug/p/debug_native.c b/libr/debug/p/debug_native.c
index ff66803ac9c..4eb519c67f3 100644
--- a/libr/debug/p/debug_native.c
+++ b/libr/debug/p/debug_native.c
@@ -175,6 +175,7 @@ static int r_debug_native_attach (RDebug *dbg, int pid) {
 	} else {
 		ret = -1;
 	}
+	// XXX: What is this for?
 	ret = w32_first_thread (pid);
 	CloseHandle (process);
 	return ret;
diff --git a/libr/debug/p/native/w32.c b/libr/debug/p/native/w32.c
index 8f8970338d5..7e005bc4795 100644
--- a/libr/debug/p/native/w32.c
+++ b/libr/debug/p/native/w32.c
@@ -156,6 +156,7 @@ typedef struct _OBJECT_TYPE_INFORMATION
 static BOOL (WINAPI *w32_QueryFullProcessImageNameA)(HANDLE, DWORD, LPTSTR, PDWORD) = NULL;
 static DWORD (WINAPI *w32_GetModuleBaseName)(HANDLE, HMODULE, LPCSTR, DWORD) = NULL;
 static BOOL (WINAPI *w32_GetModuleInformation)(HANDLE, HMODULE, LPMODULEINFO, DWORD) = NULL;
+static BOOL (WINAPI *w32_DebugActiveProcess)(DWORD) = NULL;
 static BOOL (WINAPI *w32_DebugActiveProcessStop)(DWORD) = NULL;
 static HANDLE (WINAPI *w32_openthread)(DWORD, BOOL, DWORD) = NULL;
 static BOOL (WINAPI *w32_DebugBreakProcess)(HANDLE) = NULL;
@@ -245,6 +246,9 @@ static int w32_dbg_init() {
 	/* escalate privs (required for win7/vista) */
 	w32dbg_SeDebugPrivilege ();
 	/* lookup function pointers for portability */
+	w32_DebugActiveProcess = (BOOL (WINAPI *)(DWORD))
+		GetProcAddress (GetModuleHandleA ("kernel32"),
+				"DebugActiveProcess");
 	w32_DebugActiveProcessStop = (BOOL (WINAPI *)(DWORD))
 		GetProcAddress (GetModuleHandleA ("kernel32"),
 				"DebugActiveProcessStop");
diff --git a/libr/io/p/io_debug.c b/libr/io/p/io_debug.c
index ea0eb8ab5bd..5e87101e00c 100644
--- a/libr/io/p/io_debug.c
+++ b/libr/io/p/io_debug.c
@@ -101,6 +101,35 @@ static int setup_tokens() {
 	return err;
 }
 
+static int attach_and_trace(RIO *io, int pid) {
+	DEBUG_EVENT de;
+	HANDLE ph = INVALID_HANDLE_VALUE;
+	int ret = -1;
+
+	ph = OpenProcess (PROCESS_ALL_ACCESS, FALSE, pid);
+	/* Attach to the process */
+	if (!DebugActiveProcess(pid)) goto attach_exit;
+
+	/* catch create process event */
+	if (!WaitForDebugEvent (&de, 10000)) goto attach_exit;
+
+	if (de.dwDebugEventCode != CREATE_PROCESS_DEBUG_EVENT) {
+		eprintf ("exception code 0x%04x\n", (ut32)de.dwDebugEventCode);
+		goto attach_exit;
+	}
+
+	winbase = (ut64)de.u.CreateProcessInfo.lpBaseOfImage;
+	ret = 0;
+attach_exit:
+	if (ph) {
+		CloseHandle (ph);
+	}
+	if (ret == -1) {
+		r_sys_perror ("attach_and_trace");
+	}
+	return ret;
+}
+
 static int fork_and_ptraceme(RIO *io, int bits, const char *cmd) {
 	PROCESS_INFORMATION pi;
 	STARTUPINFOA si = { sizeof (si) };
@@ -588,12 +617,22 @@ static RIODesc *__open(RIO *io, const char *file, int rw, int mode) {
 			ret = _plugin->open (io, uri, rw, mode);
 #endif
 		} else {
+#if __WINDOWS__
+			attach_and_trace (io, pid);
+#endif
 			sprintf (uri, "attach://%d", pid);
 			_plugin = r_io_plugin_resolve (io, (const char *)uri, false);
 			if (!_plugin || !_plugin->open) {
 				return NULL;
 			}
 			ret = _plugin->open (io, uri, rw, mode);
+#if __WINDOWS__
+			if (ret) {
+				RIOW32Dbg *w32 = (RIOW32Dbg *)ret->data;
+				w32->winbase = winbase;
+				w32->tid = wintid;
+			}
+#endif
 		}
 		if (ret) {
 			ret->plugin = _plugin;
diff --git a/libr/io/p/io_w32dbg.c b/libr/io/p/io_w32dbg.c
index 65a8e6fb045..28dbd653be6 100644
--- a/libr/io/p/io_w32dbg.c
+++ b/libr/io/p/io_w32dbg.c
@@ -54,11 +54,26 @@ static bool __plugin_open(RIO *io, const char *file, bool many) {
 }
 
 static int __attach (RIOW32Dbg *dbg) {
+	DEBUG_EVENT de;
 	dbg->pi.hProcess = OpenProcess (PROCESS_ALL_ACCESS, FALSE, dbg->pid);
 	if (!dbg->pi.hProcess) {
 		return -1;
 	}
+	/* Attach to the process */
+	if (!DebugActiveProcess(dbg->pid)) goto att_exit;
+
+	/* catch create process event */
+	if (!WaitForDebugEvent (&de, 10000)) goto att_exit;
+
+	if (de.dwDebugEventCode != CREATE_PROCESS_DEBUG_EVENT) {
+		eprintf ("exception code 0x%04x\n", (ut32)de.dwDebugEventCode);
+		goto att_exit;
+	}
+	dbg->winbase = (ut64)de.u.CreateProcessInfo.lpBaseOfImage;
 	return dbg->pid;
+att_exit:
+	CloseHandle (dbg->pi.hProcess);
+	return -1;
 }
 
 static RIODesc *__open(RIO *io, const char *file, int rw, int mode) {
